/*
   File: jti_shared_test9.cc
   Note: JTRON 2.0 ITRON API  ֥ͭȡ󥿡ե
   ¾浡ǽƥȥץ
   Date: 1999-10-31
   Last update: 2000-1-20

Copyright(C) 1999-2000
TOSHIBA INFORMATION SYSTEMS(JAPAN) CORPORATION. All Rights Reserved.
*/

#include <jni.h>

#include <basic.h>
#include <errcode.h>
#include <bsys/bms.h>

//#include "jcg/i_jt2ext.h"
#include "jti_common.h"
#include "jti_shared.h"


/**************
  Input data
***************/
/* shared object name */
#define SHO_NAME4        "Shared4"

/* timeout (ms)*/
#define LOCK_TIMEOUT    1000

/**************/

/*
   Test-No.: k150220, k150221
*/
void 
execITRON ()
{
  char *objnm ;
  JNO  id = 0 ;
  TMO  tmout = 0 ;
  ER   ercd = E_OK ;
  JNI_PTR  p_addr ;
  jclass  clazz ;
  jfieldID  fid ;
  jint  sho_data ;

  printf ("\n# (1) Enter: execITRON\n");

  tslp_tsk(15000);

  /* jti_get_obj */

  objnm = SHO_NAME4 ;
  id = 0 ;
  printf ("# (1) objnm: [%s], id: [%d]\n",objnm,id);
  ercd = jti_get_obj (objnm, &id) ;
  printf ("# (1) ercd: [%d], id: [%d]\n",ercd,id);
  if (ercd != E_OK)  ext_tsk () ;

  /* jti_loc_obj */

  tmout = LOCK_TIMEOUT ;
  printf ("# (1) id: [%d], tmout: [%d]\n",id,tmout);
  ercd = jti_loc_obj (id, tmout) ;
  printf ("# (1) ercd: [%d]\n",ercd);
  if (ercd != E_OK)  ext_tsk () ;

  printf ("\n# (1) s150220 - A1\n");
  p_addr.env = NULL ;
  p_addr.obj = NULL ;
  printf ("# (1) id: [%d], env: [%d], obj: [%d]\n",id,p_addr.env,p_addr.obj);
  ercd = jti_get_mem (id, (void**)&p_addr) ;
  printf ("# (1) ercd: [%d], env: [%d], obj: [%d]\n",ercd,p_addr.env,p_addr.obj);
  printf ("# (1) END: s150220 - A1\n");
  if (ercd != E_OK)  ext_tsk () ;

  /* Access shared object */
  printf ("\n# (1) s150221 - B1\n");

  printf ("# (1) [JNI]:Call GetObjectClass\n");
  clazz = p_addr.env->GetObjectClass (p_addr.obj) ;

  printf ("# (1) [JNI]:Call GetFieldID\n");
  fid = p_addr.env->GetFieldID (clazz, "data", "I") ;

  /* get data from object-field */
  printf ("# (1) [JNI]:Call GetIntField\n");
  sho_data = p_addr.env->GetIntField (p_addr.obj, fid) ;

  printf ("# (1) get: sho_data: [%d]\n",sho_data);
  printf ("# (1) END:s150221 - B1\n");

  /* jti_unl_obj */

  printf ("# (1) id: [%d]\n",id);
  ercd = jti_unl_obj (id) ;
  printf ("# (1) ercd: [%d]\n",ercd);
  if (ercd != E_OK)  ext_tsk () ;

  printf ("# (1)Exit: execITRON\n");
}
