/*
   File: s1500.c
   Note: JTRON 2.0 ITRON API  ֥ͭȡ󥿡ե
   ƥȥץ
   Date: 2000-1-19
   Last update: 2000/1/20

Copyright(C) 1999-2000
TOSHIBA INFORMATION SYSTEMS(JAPAN) CORPORATION. All Rights Reserved.
*/

#include <basic.h>
#include <errcode.h>
#include <bsys/bms.h>

#include "jcg/i_jt2ext.h"
#include <jti_common.h>
#include <jti_shared.h>

/**************
  Input data
***************/

#define SHO_NAME        "Shared_Object"
#define THR_NAME        "Shared_Thread"
#define TGR_NAME        "Shared_Thread_Group"

/* timeout (ms)*/
#define LOCK_TIMEOUT    20000

/**************/

#define TASK1_PRI    100
#define TASK_STKSZ   8192
#define toERR(class,detail)  ((ERR)((class) << 16 | (UH)(detail)))

/* Task ID */
static ID tskid1 = -1 ;

/*
   Task1: Test case no.s1500
   Test-ID.: s150001
*/
static void 
task1 ()
{
  char *objnm , *thnm, *tgnm ;
  JNO  soid, thid, tgid ;
  TMO  tmout = 0 ;
  ER   ercd = E_OK ;

  printf ("\n#(task1) ***** Start test s1500 *****\n");

  objnm = SHO_NAME ;
  soid = 0 ;
  printf ("# (1) [ITRON] 7.1.5.2 (A) ===== jti_get_obj ===== objnm:[%s], soid:[%d]\n",objnm,soid);
  ercd = jti_get_obj (objnm, &soid) ;
  printf ("# (1) ercd:[%d], soid:[%d]\n",ercd,soid);

  thnm = THR_NAME ;
  thid = 0 ;
  printf ("# (1) [ITRON] 7.1.5.3 (A) ----- jti_get_thr ----- thnm:[%s], thid:[%d]\n",thnm,thid);
  ercd = jti_get_thr (thnm, &thid) ;
  printf ("# (1) ercd:[%d], thid:[%d]\n",ercd,thid);

  tgnm = TGR_NAME ;
  tgid = 0 ;
  printf ("# (1) [ITRON] 7.1.5.4 (A) ----- jti_get_tgr ----- tgnm:[%s], tgid:[%d]\n",tgnm,tgid);
  ercd = jti_get_tgr (tgnm, &tgid) ;
  printf ("# (1) ercd:[%d], tgid:[%d]\n",ercd,tgid);

  /***************/

  printf ("# (1) [ITRON] 7.1.5.4 (D) ----- jti_rsm_tgr ----- tgid:[%d]\n",tgid);
  ercd = jti_rsm_tgr (tgid) ;
  printf ("# (1) ercd:[%d]\n",ercd);

  printf ("# (1) dly_tsk (3000)\n");
  dly_tsk (3000);

  printf ("# (1) [ITRON] 7.1.5.2 (C) =====> jti_loc_obj <===== soid:[%d]\n",soid);
  ercd = jti_loc_obj (soid, LOCK_TIMEOUT) ;
  printf ("# (1) ercd:[%d]\n",ercd);

  printf ("# (1) dly_tsk (5000)\n");
  dly_tsk (5000);

  printf ("# (1) [ITRON] 7.1.5.2 (D) <===== jti_unl_obj =====> soid:[%d]\n",soid);
  ercd = jti_unl_obj (soid) ;
  printf ("# (1) ercd:[%d]\n",ercd);

  printf ("# (1) dly_tsk (5000)\n");
  dly_tsk (5000);

  printf ("# (1) [ITRON] 7.1.5.3 (H) ----- jti_thr_stp ----- thid:[%d]\n",thid);
  ercd = jti_thr_stp (thid) ;
  printf ("# (1) ercd:[%d]\n",ercd);

  printf ("\n#(task1) ***** End test s1500 *****\n");
  ext_tsk () ;
}

/********************************************************************/

/*
   Create task
*/
static WERR
CreateTask (FP entry, PRI pri)
{
  ERR er ;
  ID  tskid ;
  T_CTSK ctsk ;

  printf ("# (C)==> CreateTask [pri]: %d\n",pri);

  ctsk.task = entry ;
  ctsk.itskpri = pri ;
  ctsk.stksz = TASK_STKSZ ;
  ctsk.tskatr = TA_HLNG | TA_RNG0 ;

  /* Create task */
  if ((er = vcre_tsk (&ctsk)) >= E_OK) {
    tskid = (ID)er ;
    /* Start task */
    if ((er = sta_tsk (tskid, 0)) < E_OK) {
      printf ("# (C)Err: sta_tsk\n") ;
      del_tsk (tskid) ;
    }
  } else {
    printf ("# (C)Err: vcre_tsk : %d\n", er) ;
  }
  printf ("# (C) task ID:%d created OK\n", tskid) ;
  return (er >= ER_OK) ? tskid : toERR(EC_INNER, er) ; 
}

/**********************************
   Test main
**********************************/
ERR
main (Bool Startup, TC *arg)
{
  printf ("# (M) Test program [3] main start !\n");

  if (Startup) {
    printf ("# (M) Startup: [TRUE]\n") ;
    /* Shared object test */
    if ((tskid1 = CreateTask (task1, TASK1_PRI)) < 0) {
      printf ("# (M)Err: CreateTask: tskid1: [%d]\n", tskid1) ;
      return (tskid1) ;
    }
    printf ("# (M) task1: OK\n") ;
    return (0) ;
  }
  else {
    printf ("# (M) Startup: [FALSE]\n") ;
    return (0) ;
  }
}
/* End of file */
